#!/usr/bin/python

# standalone.
import glob
import os
import random
import sys
import time

lang = "(null)"
authreq = None
rwait=100

pws = {}

usr = sys.argv[1]

os.chdir("/var/passfiles")

for f in glob.glob("*"):
	fd = open(f)	
	pws[os.path.basename(f)] = fd.read().strip().split("\n")


def do_help():
	global lang
	if lang == "en":
		rprint("220-KroberDyne access terminal v2.1.18-fcdb1fa [debug]")
		rprint("220-Supported commands:")
		rprint("220-HELP AUTH PASS LANG")
		rprint("WAIT DBUG^W^W200 QUIT EXIT")
	else:
		rprint("500 HELP." + lang + " not found")

def rprint(arg):
	for c in arg:
		sys.stdout.write(c)
		sys.stdout.flush()
		time.sleep(float(random.randrange(rwait)*0.002))
	print

random.seed()


rprint ("200-KroberDyne terminal VT"+ str(random.randrange(20))+". Unathorized access prohibited.")
rprint ("200 Welcome " + usr)

while True:

	rprint("> ")
	inp = sys.stdin.readline().strip().split(" ")
	cmd = inp[0].lower()

	if cmd == "help":
		do_help()
	elif cmd == "lang":
		try:
			lang = inp[1]
			rprint("200 Language set to " + lang)
		except:
			rprint("500 Failed language set")

	elif cmd == "auth":
		if authreq is None:
			authreq = random.sample(pws,3)
		rprint("202 Required " + str(authreq))

	elif cmd == "pass":
		if authreq is None:
			rprint("401 No auth requested")
			continue
		try:
			p = inp[1]
			failed = False
			for fl in authreq:
				if not p in pws[fl]:
					rprint("403-Failed "+fl)
					failed = True
				else:
					rprint("205-Passed "+fl)
			if not failed:
				acode = hex(random.randrange(100000))
                                os.system('echo success | mail -s "user ' + usr + ' code ' + acode + '" nobody@storpool.com' )
				rprint("266 Auth code: " + acode)
			else:
				rprint("414 Accesss denied")
		except:
			rprint("500 failed")

	elif cmd == "dbug":
		try:
			rprint(str(pws[inp[1]]))
		except:
			rprint("500 No data at " + hex(id(inp[1])))
	elif cmd == "wait":
		try:
			rwait=max(int(inp[1]),1)
			rprint("200 Rwait set")
		except:
			rprint("500 BAD")

	elif cmd == "quit" or cmd == "exit":
		exit(0)
	else:
		rprint("500 Unknown command, see help/manual")
